
/******************************************************************************
 *
 * Util.C
 *
 ******************************************************************************/

/******************************************************************************
 *
 * Headers
 *
 ******************************************************************************/

#include <stdio.h>
#include <ctype.h>

#include "intrinsic.h"
#include "util.h"

/******************************************************************************
 *
 * Local Constants and Macros
 *
 ******************************************************************************/

/******************************************************************************
 *
 * Local Declarations
 *
 ******************************************************************************/

/******************************************************************************
 *
 * Local Prototypes
 *
 ******************************************************************************/

/******************************************************************************
 *
 * ParseFilename
 *
 ******************************************************************************/

#ifdef VMS
extern Status ParseFilename (String source, String path, String file,
                             String type)
#else
extern Status ParseFilename (source, path, file, type)

  String source;
  String path;
  String file;
  String type;
#endif

{
  Buffer buff;
  String c1;
  String c2;
  String c3;

  /* initialize */
  if (path) strcpy (path, "");
  if (file) strcpy (file, "");
  if (type) strcpy (type, "");

  strcpy (buff, source);
  c1 = (String) strrchr (buff, '.');
  if (c1) {
    if (type) strcpy (type, c1 + 1);
    *c1 = '\0';
  }

  c2 = (String) strrchr (buff, ']');
  if (!c2) c2 = (String) strrchr (buff,':');
  if (c2) {
    if (file) strcpy (file, c2 + 1);
    *(c2 + 1) = '\0';
    if (path) strcpy (path, buff);
  }
  else {
    if ((c1) && (c1 != &buff[0])) {
      if (file) strcpy (file, buff);
    }
    else if (strlen(buff)) {
      if (file) strcpy (file, buff);
    }
  }

  /* done */
  return (Success);
}

/******************************************************************************
 *
 * BuildReplaceFilename
 *
 ******************************************************************************/

#ifdef VMS
extern Status BuildReplaceFilename (String source, String path, String file, 
                                    String type, String output)
#else
extern Status BuildReplaceFilename (source, path, file, type, output)

  String source;
  String path;
  String file;
  String type;
  String output;
#endif

{
  Buffer oldPath, oldFile, oldType;

  ParseFilename (source, oldPath, oldFile, oldType);

  if (path) strcpy (oldPath, path);
  if (file) strcpy (oldFile, file);
  if (type) strcpy (oldType, type);

  if (strlen(oldType) != 0)
    sprintf (output, "%s%s.%s", oldPath, oldFile, oldType);
  else
    sprintf (output, "%s%s", oldPath, oldFile);

  /* done */
  return (Success);
}

/******************************************************************************
 *
 * BuildDefaultFilename
 *
 ******************************************************************************/

#ifdef VMS
extern Status BuildDefaultFilename (String source, String path, String file, 
                                    String type, String output)
#else
extern Status BuildDefaultFilename (source, path, file, type, output)

  String source;
  String path;
  String file;
  String type;
  String output;
#endif

{
  Buffer oldPath, oldFile, oldType;

  ParseFilename (source, oldPath, oldFile, oldType);

  if (!strlen(oldPath)) strcpy (oldPath, path);
  if (!strlen(oldFile)) strcpy (oldFile, file);
  if (!strlen(oldType)) strcpy (oldType, type);

  if (strlen(oldType) != 0)
    sprintf (output, "%s%s.%s", oldPath, oldFile, oldType);
  else
    sprintf (output, "%s%s", oldPath, oldFile);

  /* done */
  return (Success);
}
